using System;
using Views;
using System.Windows.Forms;

class ImageScaling {
  /// <summary>
  /// Image Scaling        Bishop and Horspool         Oct 2002
  /// =============
  /// Displays an image at sizes varying at runtime.
  /// Illustrates a TrackBar as well as direct access to
  /// control attributes.
  /// </summary>
  Views.Form form;
  PictureBox pb;
  int originalWidth, originalHeight;
  string formSpec =
    @"<Form Text='Image Scaler'>
    <vertical>
      <vertical>
         <horizontal>
            <Label Text='Set Scale' Width=2cm valign=middle/>
            <TrackBar Name=scale Width=6cm Height=0.5cm Value=100/>
            <TextBox Name=percent Width=1cm Text='100%'/>
         </horizontal>
         <space Height=0.3cm/>
         <horizontal>
           <space Width=2cm/> 
           <Label Text='1%'/>
           <space Width=1.8cm/> 
           <Label Text='100%'/>
           <space Width=1cm/>
         </horizontal>
      </vertical>
      <Panel Width=12cm Height=9cm>
        <position x=0 y=0>
          <PictureBox Name=image Image={0} Width=11cm Height=8cm/>
        </position>
      </Panel>
    </vertical>
  </Form>";

  void ActionPerformed( string c ) {
    switch(c) {
      case "scale":
        int factor = form.GetValue("scale");
        form.PutText("percent", factor+"%");
        pb.Width = originalWidth*factor/100;
        pb.Height = originalHeight*factor/100;
        break;
      default:
        break;
    }
  }

  public void Go() {
    form = new Views.Form(formSpec, "Bridge.jpg");
    pb = form["image"];
    originalWidth = pb.Width;
    originalHeight = pb.Height;
    string c;
    for ( ; ; ) {
      c = form.GetControl();
      if (c==null) break;
      ActionPerformed(c);
    }
    form.CloseGUI();
  }
  static void Main() {
    new ImageScaling().Go();
  }
}
